// A.I.R. (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size) {
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos {
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[]) {
	char fname[FILENAME_MAX];
	int i,d,size;
	unsigned char id[] = " AIR (C)1986 Quasar Soft K.K.";

	struct fpos md[] = {
		{ 0x3F, 0x11, 0x0b00 },	// BOSIHARI
		{ 0x40, 0x09, 0x0a00 },	// HUNGARIAN
		{ 0x40, 0x13, 0x1300 },	// AIR THEME
		{ 0x41, 0x13, 0x0700 },	// INFINITY
		{ 0x42, 0x07, 0x0b00 },	// PRALUDIUM
		{ 0x42, 0x12, 0x0d00 },	// VICTORY MARCH
		{ 0x43, 0x0c, 0x0400 },	// THE END
		{ 0x43, 0x10, 0x0900 },	// SPACE
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};                            

	if (argc<2 || argc>3) {
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++) {
		disk.SelectDisk(d);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x100);
		if (!memcmp(&buff[0x00e3], id, sizeof(id)-1)) {
			printf("Mission Disk F܂.\n");
			// hCo؂o
			disk.SetRecordRange(0x01,0x10);
			size = disk.ReadDATA(0x05, 0x02, 0x01, 0x0f, 0x01, buff, 0x0f00);
			if (size == 0xf00) {
				for (i=0; i<0xf00; i++) {
					buff[i] ^= 0xd1;	// fR[h
				}
				// hCoo
				printf ("cutting ... DRIVER\n");
				fp = fopen("DRIVER","wb");
				fwrite(buff, 1, 0x0f00, fp);
				fclose(fp);
			}
			// ȃf[^؂o
			disk.SetRecordRange(0x01,0x13);
			for (i=0; md[i].size; i++) {
				sprintf (fname,"MUS%02d",i);
				fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x01, 0x0000, md[i].size);
			}
		}
	}
	return 0;
}

